import os,sys

def getinput():
	inputfile = raw_input('What is the name of the metatool input file (including the file extension)?\n\t')
	try:
		handle = open(inputfile,'r')
	except IOError:
		print '\nNo such file exists...Try again or hit \'ctrl+c\' to kill this script.\n'
		inputfile = getinput()
		handle = open(inputfile,'r')
	while True:
		line = handle.readline()
		if line == '':
			print 'That\'s not a metatool input file...Try again or hit \'ctrl+c\' to kill this script.\n'
			handle.close()
			inputfile = getinput()
			handle = open(inputfile,'r')
		if line.strip() == '-ENZREV':
			handle.close()
			break
	return inputfile

def getoutputpath():
	basepath = os.getcwd()
	newpath = raw_input('Name the output folder (leave empty to use current folder):\n\t')
	if newpath != '':
		try:
			os.mkdir(newpath)
		except OSError:
			pass
	if os.path.exists(os.path.join(basepath,newpath,'mnames.txt')):
		overwrite = raw_input('Overwrite?\n(y/n)\n')
		if overwrite.lower() != 'y' and overwrite.lower() != 'yes':
			print '\nChoose a different path, then.\n'
			totalpath = getoutputpath()
			return totalpath
	totalpath = os.path.join(basepath,newpath)
	return totalpath

inputfile = getinput()
outpath = getoutputpath()
methandle = open(os.path.join(outpath,'mnames.txt'),'w')
rxnhandle = open(os.path.join(outpath,'rnames.txt'),'w')
revhandle = open(os.path.join(outpath,'revs.txt'),'w')
stoihandle = open(os.path.join(outpath,'stoich.txt'),'w')

intmets = {}
revrxns = []

inputhandle = open(inputfile,'r')
while True:
	line = inputhandle.readline().strip()
	if line == '-ENZREV':
		while True:
			line = inputhandle.readline().strip()
			if line == '':
				break
			for item in line.split(' '):
				revrxns.append(item.strip())
		inputhandle.close()
		break

inputhandle = open(inputfile,'r')
while True:
	line = inputhandle.readline().strip()
	if line == '-METINT':
		while True:
			line = inputhandle.readline().strip()
			if line == '':
				break
			for item in line.split(' '):
				if len(intmets) > 0:
					methandle.write('\t')
				intmets[item] = len(intmets)
				methandle.write('\"' + item + '\"')
		inputhandle.close()
		break

inputhandle = open(inputfile,'r')
while True:
	line = inputhandle.readline().strip()
	if line == '-CAT':
		counter = 0
		columns = []
		while True:
			line = inputhandle.readline()
			if line == '':
				break
			if line.strip() == '':
				continue
			if counter > 0:
				revhandle.write('\t')
				rxnhandle.write('\t')
			counter += 1
			enz,rxn = line.split(':')
			enz = enz.strip()
			rxnhandle.write('\"' + enz + '\"')
			if enz in revrxns:
				revhandle.write('1')
			else:
				revhandle.write('0')
			rxn = rxn.strip().strip('.')
			reactants,products = rxn.split('=')
			reactants = reactants.split('+')
			numbers = []
			names = []
			for item in reactants:
				coeffmet = item.strip()
				if len(coeffmet.split(' ')) == 1:
					coeffmet = ['1', coeffmet]
				else:
					coeffmet = coeffmet.split(' ')
				if coeffmet[1] in intmets:
					numbers.append(-float(coeffmet[0]))
					names.append(coeffmet[1])
			products = products.split('+')
			for item in products:
				coeffmet = item.strip()
				if len(coeffmet.split(' ')) == 1:
					coeffmet = [1.0, coeffmet]
				else:
					coeffmet = coeffmet.split(' ')
				if coeffmet[1] in intmets:
					numbers.append(coeffmet[0])
					names.append(coeffmet[1])
			column = []
			for i in range(len(intmets)):
				column.append(0.0)
			for i in range(len(numbers)):
				column[intmets[names[i]]] = numbers[i]
			columns.append(column)
		break

for i in range(len(columns[1])):
	for j in range(len(columns)):
		if j != 0:
			stoihandle.write('\t')
		stoihandle.write(' ' + str(columns[j][i]))
	stoihandle.write('\n')

inputhandle.close()
methandle.close()
rxnhandle.close()
revhandle.close()
stoihandle.close()

